#dateList.py
############################################################################
#    External method EventFolder/Extensions/dateList.py
#    Ver 1.0  July 7 2000
#
#    License follows the Zope license, & use at your own risk
#    written and Copyright by Jeff Sasmor  (jeff@sasmor.com)
#
#############################################################################

import DateTime
import string

#############################################################################
#	edListSearch does a catalog search for events in a certain range, and
#                returns a list of event objects
#                note: dates must be a string, not a DateTime instance.
#                note: to search on only one day, just use the same date for
#                date1 and date2
##################################################################################

def edListSearch(self, date1, date2, moderatedMode):

	dt1 = DateTime.DateTime(date1)
	dt2 = DateTime.DateTime(date2)	
	first = dt1.earliestTime()	#earliest time on this date
	second = dt2.latestTime()	#latest time on this date
	edlist = []					#empty list of EventDoc instances

	arglist = {'meta_type':'EvDocDate','event_date':[first,second],'event_date_usage':'range:min:max' ,'sort_on':'event_date'}
	results = self.Catalog.searchResults(arglist)	#get all EvDocDate instances for this date.
	
	#now we have to
	#   A. get the parent EventDoc for each EvDocDate
	#   B. discard the EvDocDate if we already have the parent (num EvDocDates per EventDoc can be >1)
	#   C. Optionally see if the EventDoc is reviewed
	#   D. put the EventDoc in the list

	if not results:		#this really shouldn't happen...
		return []
		
	#implied else:
	for item in results:	#loop thru the results
		obj = self.Catalog.getobject(item.data_record_id_)	#get the object from the result item (an EvDocDate)
		pn = obj.getParentNode()							#and get the object's parent (an EventDoc)
		flag = '0'  		
		
		#you'd think that you could replace the following with     if pn in edlist    but it doesn't work. Mystery.
		#nor does a loop that has the comparison as Node == pn.  These should be the same instance, so why?
		for Node in edlist:					#if this EventDoc isn't already in the list
			if Node.id == pn.id:
				flag = '1'
				break
		if flag == '0':
		#If moderatedMode=='on' we have to chk the parent obj (the event doc) to see if it has the reviewed property == on
			if moderatedMode=='on':			
				if pn.reviewed == 'on':
					edlist.append(pn)			#if moderated and this was reviewed, add it
			else:
				edlist.append(pn)				#else always append it.
	
	return edlist
	
